#define STRICT
#include <windows.h>
#pragma hdrstop

#include <stdio.h>
#include <stdarg.h>

FILE* log = NULL;

bool open_log(const char* fn)
{
   log = fopen(fn, "wt");
   if( !log ) return false;

   SYSTEMTIME time;
   GetLocalTime( &time );

   fprintf( log, "\nOpen log: %u-%02u-%02u %02u:%02u:%02u.%03u\n",
      time.wYear, time.wMonth, time.wDay,
      time.wHour, time.wMinute, time.wSecond, time.wMilliseconds );
      
   fflush( log );

   return false;
}

void close_log()
{
   if( log )
   {
      SYSTEMTIME time;
      GetLocalTime( &time );

      fprintf( log, "Close log: %u-%02u-%02u %02u:%02u:%02u.%03u\n\n\n",
         time.wYear, time.wMonth, time.wDay,
         time.wHour, time.wMinute, time.wSecond, time.wMilliseconds );

      fclose( log );
      log = NULL;
   }
}

void __cdecl dprintf(const char* format, ...)
{
   if( log && format )
   {
      SYSTEMTIME time;
      GetLocalTime( &time );

      fprintf( log, "%02u:%02u:%02u.%03u ",
         time.wHour, time.wMinute, time.wSecond, time.wMilliseconds );

#ifndef _MSC_VER
      try{
#endif
      try
      {
         va_list arglist;
         va_start( arglist, format );
         vfprintf( log, format, arglist );
         va_end( arglist );
         fflush( log );
#ifndef _MSC_VER
      } __except( 1 ) {}
#endif
      } catch(...) {}
   }
}

